(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('ng-zorro-antd/grid'), require('ng-zorro-antd/button'), require('ng-zorro-antd/icon'), require('rxjs/operators'), require('ng-zorro-antd/input'), require('ng-zorro-antd/spin'), require('ng-zorro-antd/table'), require('ng-zorro-antd/switch'), require('ng-zorro-antd/dropdown'), require('ng-zorro-antd/core/wave'), require('ng-zorro-antd/core/transition-patch'), require('ng-zorro-antd/menu'), require('ng-zorro-antd/pagination'), require('@angular/router'), require('ng-zorro-antd/page-header'), require('ng-zorro-antd/tabs'), require('ng-zorro-antd/breadcrumb'), require('ng-zorro-antd/tag'), require('ng-zorro-antd/anchor'), require('ng-zorro-antd/card'), require('ng-zorro-antd/cascader'), require('ng-zorro-antd/collapse'), require('ng-zorro-antd/divider'), require('ng-zorro-antd/drawer'), require('ng-zorro-antd/form'), require('ng-zorro-antd/input-number'), require('ng-zorro-antd/message'), require('ng-zorro-antd/modal'), require('ng-zorro-antd/radio'), require('ng-zorro-antd/result'), require('ng-zorro-antd/select'), require('ng-zorro-antd/space'), require('ng-zorro-antd/tooltip'), require('ng-zorro-antd/typography'), require('@ant-design/icons-angular/icons')) :
    typeof define === 'function' && define.amd ? define('umbrella-library', ['exports', '@angular/core', '@angular/common', '@angular/forms', 'ng-zorro-antd/grid', 'ng-zorro-antd/button', 'ng-zorro-antd/icon', 'rxjs/operators', 'ng-zorro-antd/input', 'ng-zorro-antd/spin', 'ng-zorro-antd/table', 'ng-zorro-antd/switch', 'ng-zorro-antd/dropdown', 'ng-zorro-antd/core/wave', 'ng-zorro-antd/core/transition-patch', 'ng-zorro-antd/menu', 'ng-zorro-antd/pagination', '@angular/router', 'ng-zorro-antd/page-header', 'ng-zorro-antd/tabs', 'ng-zorro-antd/breadcrumb', 'ng-zorro-antd/tag', 'ng-zorro-antd/anchor', 'ng-zorro-antd/card', 'ng-zorro-antd/cascader', 'ng-zorro-antd/collapse', 'ng-zorro-antd/divider', 'ng-zorro-antd/drawer', 'ng-zorro-antd/form', 'ng-zorro-antd/input-number', 'ng-zorro-antd/message', 'ng-zorro-antd/modal', 'ng-zorro-antd/radio', 'ng-zorro-antd/result', 'ng-zorro-antd/select', 'ng-zorro-antd/space', 'ng-zorro-antd/tooltip', 'ng-zorro-antd/typography', '@ant-design/icons-angular/icons'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["umbrella-library"] = {}, global.ng.core, global.ng.common, global.ng.forms, global.i2$2, global.i3, global.i9, global.rxjs.operators, global.i1, global.i2$1, global.i3$1, global.i2, global.i4, global.i7$1, global.i8, global.i10, global.i5$1, global.ng.router, global.i1$1, global.i6, global.i2$3, global.i3$2, global.anchor, global.card, global.cascader, global.collapse, global.divider, global.drawer, global.form, global.inputNumber, global.message, global.modal, global.radio, global.result, global.select, global.space, global.tooltip, global.typography, global.icons$1));
})(this, (function (exports, i0, i5, i7, i2$2, i3, i9, operators, i1, i2$1, i3$1, i2, i4, i7$1, i8, i10, i5$1, i8$1, i1$1, i6, i2$3, i3$2, anchor, card, cascader, collapse, divider, drawer, form, inputNumber, message, modal, radio, result, select, space, tooltip, typography, icons$1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i5__namespace = /*#__PURE__*/_interopNamespace(i5);
    var i7__namespace = /*#__PURE__*/_interopNamespace(i7);
    var i2__namespace$3 = /*#__PURE__*/_interopNamespace(i2$2);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);
    var i9__namespace = /*#__PURE__*/_interopNamespace(i9);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i2__namespace$1 = /*#__PURE__*/_interopNamespace(i2$1);
    var i3__namespace$1 = /*#__PURE__*/_interopNamespace(i3$1);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i4__namespace = /*#__PURE__*/_interopNamespace(i4);
    var i7__namespace$1 = /*#__PURE__*/_interopNamespace(i7$1);
    var i8__namespace = /*#__PURE__*/_interopNamespace(i8);
    var i10__namespace = /*#__PURE__*/_interopNamespace(i10);
    var i5__namespace$1 = /*#__PURE__*/_interopNamespace(i5$1);
    var i8__namespace$1 = /*#__PURE__*/_interopNamespace(i8$1);
    var i1__namespace$1 = /*#__PURE__*/_interopNamespace(i1$1);
    var i6__namespace = /*#__PURE__*/_interopNamespace(i6);
    var i2__namespace$2 = /*#__PURE__*/_interopNamespace(i2$3);
    var i3__namespace$2 = /*#__PURE__*/_interopNamespace(i3$2);

    exports.ResponseStatus = void 0;
    (function (ResponseStatus) {
        ResponseStatus["Success"] = "SUCCESS";
        ResponseStatus["Failed"] = "FAILED";
    })(exports.ResponseStatus || (exports.ResponseStatus = {}));

    var UmbrellaLibraryService = /** @class */ (function () {
        function UmbrellaLibraryService() {
        }
        UmbrellaLibraryService.prototype.isSuccessfulResponse = function (response) {
            return response.responseStatus === 'SUCCESS';
        };
        return UmbrellaLibraryService;
    }());
    UmbrellaLibraryService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    UmbrellaLibraryService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root',
                    }]
            }], ctorParameters: function () { return []; } });

    var UmbrellaLibraryComponent = /** @class */ (function () {
        function UmbrellaLibraryComponent() {
        }
        UmbrellaLibraryComponent.prototype.ngOnInit = function () { };
        return UmbrellaLibraryComponent;
    }());
    UmbrellaLibraryComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    UmbrellaLibraryComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: UmbrellaLibraryComponent, selector: "lib-umbrella-library", ngImport: i0__namespace, template: " <p>umbrella-library is amazing!</p> ", isInline: true });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-umbrella-library',
                        template: " <p>umbrella-library is amazing!</p> ",
                        styles: [],
                    }]
            }], ctorParameters: function () { return []; } });

    exports.DataTableColumnFormatType = void 0;
    (function (DataTableColumnFormatType) {
        DataTableColumnFormatType["date"] = "date";
        DataTableColumnFormatType["boolean"] = "boolean";
        DataTableColumnFormatType["statusToggle"] = "statusToggle";
        DataTableColumnFormatType["nestedAttribute"] = "nestedAttribute";
        DataTableColumnFormatType["menuDropdownActions"] = "menuDropdownActions";
        DataTableColumnFormatType["templateRef"] = "templateRef";
        DataTableColumnFormatType["contacts"] = "contacts";
    })(exports.DataTableColumnFormatType || (exports.DataTableColumnFormatType = {}));

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }

    /**
     *
     * @param object a table data record
     * @param nestedAttributePath the path of a nested attribute to display
     * @returns the value of a sub object located at the nested path of the input object
     * @example
     * ```ts
     * const exObj = {fleet: {vehicleGroup: {id: 1, name: 'v group 1'}}};
     * const nestedValue = getNestedAttribute(exObj, 'fleet.vehicleGroup.name');
     * console.log(nestedValue);
     * // v group 1
     * ```
     */
    function getNestedAttribute(object, nestedAttributePath) {
        var e_1, _a;
        var nestedAttributes = nestedAttributePath.split('.');
        var nestedAttributeValue = object;
        try {
            for (var nestedAttributes_1 = __values(nestedAttributes), nestedAttributes_1_1 = nestedAttributes_1.next(); !nestedAttributes_1_1.done; nestedAttributes_1_1 = nestedAttributes_1.next()) {
                var nestedAttribute = nestedAttributes_1_1.value;
                if (nestedAttributeValue[nestedAttribute]) {
                    nestedAttributeValue = nestedAttributeValue[nestedAttribute];
                }
                else {
                    nestedAttributeValue = undefined;
                    break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (nestedAttributes_1_1 && !nestedAttributes_1_1.done && (_a = nestedAttributes_1.return)) _a.call(nestedAttributes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return nestedAttributeValue;
    }

    var CustomDataTableCellComponent = /** @class */ (function () {
        function CustomDataTableCellComponent(cdr, library) {
            this.cdr = cdr;
            this.library = library;
            this.dataTableColumnFormatType = exports.DataTableColumnFormatType;
            this.getNestedAttribute = getNestedAttribute;
        }
        CustomDataTableCellComponent.prototype.onStatusToggleClick = function (event, column, record) {
            var _this = this;
            var _a;
            if (((_a = column.format) === null || _a === void 0 ? void 0 : _a.type) === exports.DataTableColumnFormatType.statusToggle) {
                this.loadingStatusToggleRecordId = record.id;
                column.format
                    .action(record.id, Object.assign(Object.assign({}, record), { status: !record.status }))
                    .pipe(operators.finalize(function () {
                    _this.loadingStatusToggleRecordId = -1;
                    _this.cdr.markForCheck();
                }))
                    .subscribe(function (response) {
                    if (!_this.library.isSuccessfulResponse(response)) {
                        event.preventDefault();
                    }
                    else {
                        record.status = !record.status;
                    }
                });
            }
        };
        return CustomDataTableCellComponent;
    }());
    CustomDataTableCellComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: CustomDataTableCellComponent, deps: [{ token: i0__namespace.ChangeDetectorRef }, { token: UmbrellaLibraryService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    CustomDataTableCellComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: CustomDataTableCellComponent, selector: "x-custom-data-table-cell", inputs: { column: "column", record: "record" }, ngImport: i0__namespace, template: "<ng-container *ngIf=\"column.format\" [ngSwitch]=\"column.format.type\">\n  <!-- Date -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.date\">\n    {{ record[column.field] | date: 'd MMM yyyy' }}\n  </span>\n  <!-- Boolean -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.boolean\">\n    {{ record[column.field] ? column.format.true : column.format.false }}\n  </span>\n  <!-- Contacts -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.contacts\">\n    <span *ngIf=\"!record[column.field].length\">\n      {{ record[column.field].firstName }}\n      {{ record[column.field].lastName }}\n    </span>\n    <span *ngFor=\"let c of record[column.field]; last as isLast\" class=\"capitalize\">\n      {{ c.firstName }} {{ c.lastName }}<br *ngIf=\"!isLast\" />\n    </span>\n  </span>\n  <!-- Status -->\n  <nz-switch\n    *ngSwitchCase=\"dataTableColumnFormatType.statusToggle\"\n    [nzLoading]=\"loadingStatusToggleRecordId === record.id\"\n    (click)=\"onStatusToggleClick($event, column, record)\"\n    [ngModel]=\"record.status\"></nz-switch>\n  <!-- Nested Attribute -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.nestedAttribute\">\n    {{ getNestedAttribute(record, column.field) }}\n  </span>\n  <!-- Edit, Delete and more Action Buttons -->\n  <ng-container *ngSwitchCase=\"dataTableColumnFormatType.menuDropdownActions\">\n    <div\n      class=\"x-data-table-dropdown-menu-cell hidden\"\n      *ngIf=\"column.format?.dropdownActionItems?.length\">\n      <button\n        nz-button\n        nzNoAnimation\n        nz-dropdown\n        [nzDropdownMenu]=\"menu\"\n        style=\"border: none; padding: 0\">\n        <i\n          nz-icon\n          nzType=\"ellipsis\"\n          nzTheme=\"outline\"\n          style=\"font-size: 20px; vertical-align: top\"></i>\n      </button>\n      <nz-dropdown-menu #menu=\"nzDropdownMenu\">\n        <ul nz-menu>\n          <li\n            *ngFor=\"let dropdownItem of column.format.dropdownActionItems\"\n            nz-menu-item\n            (click)=\"dropdownItem.action(record)\">\n            <span>\n              <i nz-icon [nzType]=\"dropdownItem.nzIconName\"></i>\n              {{ dropdownItem.text }}\n            </span>\n          </li>\n        </ul>\n      </nz-dropdown-menu>\n    </div>\n  </ng-container>\n</ng-container>\n", styles: [".x-data-table-dropdown-menu-cell{display:inline-flex!important}.x-data-table-dropdown-menu-cell button{border:1.5px solid #00000026;width:32px}\n"], components: [{ type: i2__namespace.NzSwitchComponent, selector: "nz-switch", inputs: ["nzLoading", "nzDisabled", "nzControl", "nzCheckedChildren", "nzUnCheckedChildren", "nzSize"], exportAs: ["nzSwitch"] }, { type: i3__namespace.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { type: i4__namespace.NzDropdownMenuComponent, selector: "nz-dropdown-menu", exportAs: ["nzDropdownMenu"] }], directives: [{ type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5__namespace.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i5__namespace.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i5__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i7__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i7__namespace.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i7__namespace$1.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { type: i8__namespace.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { type: i4__namespace.NzDropdownButtonDirective, selector: "[nz-button][nz-dropdown]" }, { type: i4__namespace.NzDropDownDirective, selector: "[nz-dropdown]", inputs: ["nzDropdownMenu", "nzTrigger", "nzMatchWidthElement", "nzHasBackdrop", "nzBackdrop", "nzClickHide", "nzDisabled", "nzVisible", "nzOverlayClassName", "nzOverlayStyle", "nzPlacement"], outputs: ["nzVisibleChange"], exportAs: ["nzDropdown"] }, { type: i9__namespace.NzIconDirective, selector: "[nz-icon]", inputs: ["nzRotate", "nzSpin", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { type: i10__namespace.NzMenuDirective, selector: "[nz-menu]", inputs: ["nzInlineIndent", "nzTheme", "nzMode", "nzInlineCollapsed", "nzSelectable"], outputs: ["nzClick"], exportAs: ["nzMenu"] }, { type: i10__namespace.NzMenuItemDirective, selector: "[nz-menu-item]", inputs: ["nzDisabled", "nzSelected", "nzDanger", "nzMatchRouterExact", "nzMatchRouter", "nzPaddingLeft"], exportAs: ["nzMenuItem"] }], pipes: { "date": i5__namespace.DatePipe }, changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: CustomDataTableCellComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'x-custom-data-table-cell',
                        templateUrl: './custom-data-table-cell.component.html',
                        styleUrls: ['./custom-data-table-cell.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ChangeDetectorRef }, { type: UmbrellaLibraryService }]; }, propDecorators: { column: [{
                    type: i0.Input
                }], record: [{
                    type: i0.Input
                }] } });

    var DataTableComponent = /** @class */ (function () {
        function DataTableComponent() {
            this.totalRecordsCount = 0;
            this.pageSize = 10;
            this.loading = false;
            this.selectable = false;
            this.selectedRecordsSet = new Set();
            this.fetchRecords = new i0.EventEmitter();
            this.selectRecord = new i0.EventEmitter();
            this.dataTableColumnFormatType = exports.DataTableColumnFormatType;
            this.PAGE_SIZE_OPTIONS = this.displaySizeOptions || [5, 10, 20, 50, 100];
            this.currentPageIndex = 1;
            this.currentPageStart = 0;
            this.currentPageEnd = 0;
            this.searchControl = new i7.FormControl('');
        }
        DataTableComponent.prototype.ngOnInit = function () {
            this._fetchRecords();
            this._subscribeToSearchControlChanges();
        };
        DataTableComponent.prototype.ngOnChanges = function (changes) {
            if (changes.records.currentValue !== 'undefined' ||
                changes.totalRecordsCount.currentValue !== 'undefined') {
                this.loading = false;
                this._setPaginationStartAndEnd();
            }
        };
        DataTableComponent.prototype.reset = function () {
            this._resetPagination();
            if (this.searchControl.value) {
                this.clearSearch();
            }
            else {
                this._fetchRecords();
            }
        };
        DataTableComponent.prototype.clearSearch = function () {
            this.searchControl.setValue('');
            this.searchControl.updateValueAndValidity();
        };
        /* Handle Selection Checkboxes */
        DataTableComponent.prototype.updateCheckedSet = function (id, checked) {
            if (checked) {
                this.selectedRecordsSet.add(id);
            }
            else {
                this.selectedRecordsSet.delete(id);
            }
        };
        DataTableComponent.prototype.onAllChecked = function (checked) {
            var _this = this;
            this.records.forEach(function (rec) { return _this.updateCheckedSet(rec.id, checked); });
            this.selectRecord.emit(this.selectedRecordsSet);
        };
        DataTableComponent.prototype.onItemChecked = function (id, checked) {
            this.updateCheckedSet(id, checked);
            this.selectRecord.emit(this.selectedRecordsSet);
        };
        /* Handle Pagination */
        DataTableComponent.prototype.onPageSizeChanged = function (size) {
            this.pageSize = size;
            this.currentPageIndex = 1;
            this._fetchRecords();
        };
        DataTableComponent.prototype.onPageIndexChanged = function (pageIndex) {
            this.currentPageIndex = pageIndex;
            this._fetchRecords();
        };
        DataTableComponent.prototype._subscribeToSearchControlChanges = function () {
            var _this = this;
            this.searchControl.valueChanges
                .pipe(operators.debounceTime(300), operators.distinctUntilChanged())
                .subscribe(function () {
                _this._resetPagination();
                _this._fetchRecords();
            });
        };
        DataTableComponent.prototype._resetPagination = function () {
            this.currentPageIndex = 1;
            this.currentPageStart = 0;
            this.currentPageEnd = 0;
        };
        DataTableComponent.prototype._fetchRecords = function () {
            this.loading = true;
            this.fetchRecords.emit({
                searchKey: this.searchControl.value,
                /* @TODO Implement sorting or remove this */
                //sortOrder: this._getSortOrder(),
                //sortField: this.sortedColumn?.field,
                paginationInfo: { pageNumber: this.currentPageIndex, pageSize: this.pageSize },
            });
        };
        DataTableComponent.prototype._setPaginationStartAndEnd = function () {
            var start = (this.currentPageIndex - 1) * this.pageSize;
            this.currentPageStart = this.totalRecordsCount ? start + 1 : start;
            this.currentPageEnd = start + this.pageSize;
            this.currentPageEnd =
                this.currentPageEnd > this.totalRecordsCount ? this.totalRecordsCount : this.currentPageEnd;
        };
        return DataTableComponent;
    }());
    DataTableComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DataTableComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    DataTableComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: DataTableComponent, selector: "x-data-table", inputs: { columns: "columns", records: "records", displaySizeOptions: "displaySizeOptions", totalRecordsCount: "totalRecordsCount", pageSize: "pageSize", label: "label", loading: "loading", selectable: "selectable", selectedRecordsSet: "selectedRecordsSet", customCellTemplateRef: "customCellTemplateRef" }, outputs: { fetchRecords: "fetchRecords", selectRecord: "selectRecord" }, usesOnChanges: true, ngImport: i0__namespace, template: "<div class=\"x-table-card margin-24px\">\n  <div class=\"x-table-container\">\n    <div class=\"x-table-topbar\">\n      <nz-input-group\n        class=\"x-table-search-input\"\n        attr.data-testid=\"{{ label + '-table-search' }}\"\n        [nzPrefix]=\"iconSearchTemplate\"\n        [nzSuffix]=\"inputClearTemplate\">\n        <input [formControl]=\"searchControl\" type=\"text\" nz-input placeholder=\"Search...\" />\n      </nz-input-group>\n      <!-- Download Button\n        @TODO Remove if we will not implement\n         <button attr.data-testid=\"{{ page + '-record-org-download' }}\"\n          class=\"x-download-button\"\n          nz-tooltip\n          nzTooltipTitle=\"Download CSV\"\n          nz-button\n          nzType=\"default\"\n          (click)=\"downloadCsv()\"\n          [disabled]=\"downloading\">\n          <x-svg-icon name=\"lp_operations_download\"></x-svg-icon>\n          <i nz-icon\n              [nzType]=\"'loading'\"\n              class=\"x-button-loader-icon\"></i>\n        </button>\n      -->\n    </div>\n    <div *ngIf=\"loading\" class=\"x-table-spinner\">\n      <nz-spin\n        nzSimple\n        class=\"x-table-spinner-spinning\"\n        [nzIndicator]=\"indicatorTemplate\"></nz-spin>\n      <p>Loading...</p>\n    </div>\n    <div [class.x-table-loading]=\"loading\">\n      <div class=\"x-table\">\n        <nz-table\n          attr.data-testid=\"{{ label + '-table' }}\"\n          #nzTable\n          [nzData]=\"records\"\n          nzTableLayout=\"fixed\"\n          [nzFrontPagination]=\"false\">\n          <thead>\n            <tr>\n              <th\n                *ngIf=\"selectable\"\n                id=\"checkbox-header\"\n                attr.qa-test-id=\"checkbox-header\"\n                [nzShowCheckbox]=\"true\"\n                (nzCheckedChange)=\"onAllChecked($event)\"\n                [nzWidth]=\"'100px'\"></th>\n              <ng-container *ngFor=\"let column of columns\">\n                <th [nzWidth]=\"column.width\" [class]=\"column.headerClass\">\n                  <!-- @TODO Implement sorting\n                  [nzSortFn]=\"column.sort\"\n                  [(nzSortOrder)]=\"column.sortOrder\"\n                  (nzSortOrderChange)=\"onSortingChanged(column)\">\n                  -->\n                  {{ column.name }}\n                </th>\n              </ng-container>\n            </tr>\n          </thead>\n\n          <tbody>\n            <tr *ngFor=\"let record of nzTable.data\">\n              <td\n                *ngIf=\"selectable\"\n                attr.qa-test-id=\"{{ 'checkbox-record' + record.id }}\"\n                [nzChecked]=\"selectedRecordsSet.has(record.id)\"\n                [nzShowCheckbox]=\"true\"\n                (nzCheckedChange)=\"onItemChecked(record.id, $event)\"></td>\n              <ng-container *ngFor=\"let column of columns\">\n                <!-- LOOP THROUGH DISPLAYED COLUMNS -->\n                <td [class]=\"column.cellClass\">\n                  <span *ngIf=\"!column.format\">{{ record[column.field] }}</span>\n\n                  <!-- HANDLE SPECIAL FORMATS -->\n                  <!-- As a custom template ref -->\n                  <ng-container\n                    *ngIf=\"\n                      customCellTemplateRef &&\n                      column.format?.type === dataTableColumnFormatType.templateRef\n                    \"\n                    [ngTemplateOutlet]=\"customCellTemplateRef\"\n                    [ngTemplateOutletContext]=\"{ column: column, record: record }\">\n                  </ng-container>\n                  <!-- Or one of most commonly used format type cases -->\n\n                  <x-custom-data-table-cell\n                    *ngIf=\"\n                      column.format && column.format?.type !== dataTableColumnFormatType.templateRef\n                    \"\n                    [column]=\"column\"\n                    [record]=\"record\">\n                  </x-custom-data-table-cell>\n                </td>\n              </ng-container>\n            </tr>\n          </tbody>\n        </nz-table>\n      </div>\n\n      <div\n        class=\"x-table-pagination margin-right-24px\"\n        attr.data-testid=\"{{ label + '-pagination' }}\">\n        <p class=\"x-table-pagination-info\">\n          Showing {{ currentPageStart }} - {{ currentPageEnd }} of {{ totalRecordsCount }}\n          {{ label }}\n        </p>\n        <nz-pagination\n          [nzPageIndex]=\"currentPageIndex\"\n          [nzTotal]=\"totalRecordsCount\"\n          [nzPageSize]=\"pageSize\"\n          [nzPageSizeOptions]=\"PAGE_SIZE_OPTIONS\"\n          (nzPageSizeChange)=\"onPageSizeChanged($event)\"\n          (nzPageIndexChange)=\"onPageIndexChanged($event)\"\n          nzShowSizeChanger></nz-pagination>\n      </div>\n    </div>\n  </div>\n</div>\n\n<ng-template #indicatorTemplate><i nz-icon nzType=\"loading\"></i></ng-template>\n\n<ng-template #iconSearchTemplate>\n  <i class=\"x-table-search-icon\" nz-icon nzType=\"search\"></i>\n</ng-template>\n<ng-template #inputClearTemplate>\n  <i\n    nz-icon\n    class=\"ant-input-clear-icon\"\n    nzTheme=\"fill\"\n    nzType=\"close-circle\"\n    *ngIf=\"searchControl.value\"\n    (click)=\"clearSearch()\"></i>\n</ng-template>\n", styles: [".x-table-card{background:var(--x-color-neutral-surface);box-shadow:0 0 1px #0000001a,0 1px 3px #0000001f;border-radius:6px}.x-table-container .x-table-topbar{padding:24px;border-bottom:1px solid var(--x-color-border-normal);display:flex;justify-content:flex-start}.x-table-container .x-table-topbar .fm-search-input{width:360px}.x-table-container .x-table-topbar .fm-search-input input::placeholder{color:var(--x-color-text-on-surface-subtle);font-style:italic}.x-table-container .x-table-topbar .x-table-search-icon{color:var(--x-color-text-on-surface-subtle);margin-right:6px}.x-table-container .x-table-topbar .x-table-download-button{padding:6px;margin-left:12px}.x-table-container .x-table-topbar .x-table-download-button x-svg-icon{color:var(--x-color-text-on-surface-strong);height:18px;width:18px;line-height:18px}.x-table-container .x-table-topbar .x-table-download-button i{display:none}.x-table-container .x-table-topbar .x-table-download-button:disabled x-svg-icon{display:none}.x-table-container .x-table-topbar .x-table-download-button:disabled i{display:flex}.x-table-container .x-table{padding:4px 0}.x-table-container .x-table tr{height:80px}.x-table-container .x-table tr>th{padding:24px 16px;background:var(--x-color-background-surface);color:var(--x-color-text-on-surface-strong);font-weight:600;line-height:18px;overflow:auto}.x-table-container .x-table tr>th:before{display:none}.x-table-container .x-table tr>td{padding:12px 16px;color:var(--x-color-text-on-surface-strong)}.x-table-container .x-table tr:hover>td{background-color:var(--x-focus-subtle)!important}.x-table-container .x-table tr td:first-of-type,.x-table-container .x-table tr th:first-of-type{padding-left:24px}.x-table-container .x-table tr td:last-of-type,.x-table-container .x-table tr th:last-of-type{padding-right:24px}.x-table-container .x-table-expandable-icon{display:none}.x-table-container .x-table-number-type{font-size:14px;line-height:22px;color:var(--x-color-text-on-surface-subtle)}.x-table-container .x-table-number-type a{display:block;font-weight:600;color:var(--x-color-text-on-surface-link)}.x-table-container .x-table-number-type a:hover{text-decoration:underline}.x-table-container .x-table-tag{font-size:14px;line-height:18px;padding:3px 8px;background:var(--x-color-system-subtle-grey);border:none}.x-table-loading{display:none}.x-table-pagination{padding:24px;display:flex;align-items:center}.x-table-pagination .x-table-pagination-info{margin:0;flex:1}.x-table-spinner{padding:80px;text-align:center}.x-table-spinner .x-table-spinner-spinning i{font-size:48px;color:var(--x-color-primary-main)}.x-table-spinner p{margin:20px 0 0;color:var(--x-color-text-on-surface-subtle);font-weight:400;font-size:16px;line-height:20px}\n"], components: [{ type: i1__namespace.NzInputGroupComponent, selector: "nz-input-group", inputs: ["nzAddOnBeforeIcon", "nzAddOnAfterIcon", "nzPrefixIcon", "nzSuffixIcon", "nzSize", "nzSearch", "nzCompact", "nzAddOnBefore", "nzAddOnAfter", "nzPrefix", "nzSuffix"], exportAs: ["nzInputGroup"] }, { type: i2__namespace$1.NzSpinComponent, selector: "nz-spin", inputs: ["nzIndicator", "nzSize", "nzTip", "nzDelay", "nzSimple", "nzSpinning"], exportAs: ["nzSpin"] }, { type: i3__namespace$1.NzTableComponent, selector: "nz-table", inputs: ["nzTableLayout", "nzShowTotal", "nzItemRender", "nzTitle", "nzFooter", "nzNoResult", "nzPageSizeOptions", "nzVirtualItemSize", "nzVirtualMaxBufferPx", "nzVirtualMinBufferPx", "nzVirtualForTrackBy", "nzLoadingDelay", "nzPageIndex", "nzPageSize", "nzTotal", "nzWidthConfig", "nzData", "nzPaginationPosition", "nzScroll", "nzPaginationType", "nzFrontPagination", "nzTemplateMode", "nzShowPagination", "nzLoading", "nzOuterBordered", "nzLoadingIndicator", "nzBordered", "nzSize", "nzShowSizeChanger", "nzHideOnSinglePage", "nzShowQuickJumper", "nzSimple"], outputs: ["nzPageSizeChange", "nzPageIndexChange", "nzQueryParams", "nzCurrentPageDataChange"], exportAs: ["nzTable"] }, { type: i3__namespace$1.NzTheadComponent, selector: "thead:not(.ant-table-thead)", outputs: ["nzSortOrderChange"] }, { type: i3__namespace$1.NzThSelectionComponent, selector: "th[nzSelections],th[nzChecked],th[nzShowCheckbox],th[nzShowRowSelection]", inputs: ["nzSelections", "nzChecked", "nzDisabled", "nzIndeterminate", "nzShowCheckbox", "nzShowRowSelection"], outputs: ["nzCheckedChange"] }, { type: i3__namespace$1.NzTbodyComponent, selector: "tbody" }, { type: i3__namespace$1.NzTdAddOnComponent, selector: "td[nzChecked], td[nzDisabled], td[nzIndeterminate], td[nzIndentSize], td[nzExpand], td[nzShowExpand], td[nzShowCheckbox]", inputs: ["nzChecked", "nzDisabled", "nzIndeterminate", "nzIndentSize", "nzShowExpand", "nzShowCheckbox", "nzExpand"], outputs: ["nzCheckedChange", "nzExpandChange"] }, { type: CustomDataTableCellComponent, selector: "x-custom-data-table-cell", inputs: ["column", "record"] }, { type: i5__namespace$1.NzPaginationComponent, selector: "nz-pagination", inputs: ["nzShowTotal", "nzItemRender", "nzSize", "nzPageSizeOptions", "nzShowSizeChanger", "nzShowQuickJumper", "nzSimple", "nzDisabled", "nzResponsive", "nzHideOnSinglePage", "nzTotal", "nzPageIndex", "nzPageSize"], outputs: ["nzPageSizeChange", "nzPageIndexChange"], exportAs: ["nzPagination"] }], directives: [{ type: i8__namespace.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { type: i1__namespace.NzInputGroupWhitSuffixOrPrefixDirective, selector: "nz-input-group[nzSuffix], nz-input-group[nzPrefix]" }, { type: i1__namespace.NzInputDirective, selector: "input[nz-input],textarea[nz-input]", inputs: ["nzBorderless", "nzSize", "disabled"], exportAs: ["nzInput"] }, { type: i7__namespace.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i7__namespace.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i7__namespace.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3__namespace$1.NzTrDirective, selector: "tr:not([mat-row]):not([mat-header-row]):not([nz-table-measure-row]):not([nzExpand]):not([nz-table-fixed-row])" }, { type: i3__namespace$1.NzTableCellDirective, selector: "th:not(.nz-disable-th):not([mat-cell]), td:not(.nz-disable-td):not([mat-cell])" }, { type: i3__namespace$1.NzThMeasureDirective, selector: "th", inputs: ["nzWidth", "colspan", "colSpan", "rowspan", "rowSpan"] }, { type: i5__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i5__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i9__namespace.NzIconDirective, selector: "[nz-icon]", inputs: ["nzRotate", "nzSpin", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }], changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: DataTableComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'x-data-table',
                        templateUrl: './data-table.component.html',
                        styleUrls: ['./data-table.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { columns: [{
                    type: i0.Input
                }], records: [{
                    type: i0.Input
                }], displaySizeOptions: [{
                    type: i0.Input
                }], totalRecordsCount: [{
                    type: i0.Input
                }], pageSize: [{
                    type: i0.Input
                }], label: [{
                    type: i0.Input
                }], loading: [{
                    type: i0.Input
                }], selectable: [{
                    type: i0.Input
                }], selectedRecordsSet: [{
                    type: i0.Input
                }], customCellTemplateRef: [{
                    type: i0.Input
                }], fetchRecords: [{
                    type: i0.Output
                }], selectRecord: [{
                    type: i0.Output
                }] } });

    var UmbrellaDataTableModule = /** @class */ (function () {
        function UmbrellaDataTableModule() {
        }
        return UmbrellaDataTableModule;
    }());
    UmbrellaDataTableModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaDataTableModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    UmbrellaDataTableModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaDataTableModule, declarations: [DataTableComponent, CustomDataTableCellComponent], imports: [i5.CommonModule,
            i7.FormsModule,
            i7.ReactiveFormsModule,
            i3.NzButtonModule,
            i4.NzDropDownModule,
            i2$2.NzGridModule,
            i9.NzIconModule,
            i1.NzInputModule,
            i5$1.NzPaginationModule,
            i2$1.NzSpinModule,
            i2.NzSwitchModule,
            i3$1.NzTableModule], exports: [DataTableComponent] });
    UmbrellaDataTableModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaDataTableModule, imports: [[
                i5.CommonModule,
                i7.FormsModule,
                i7.ReactiveFormsModule,
                i3.NzButtonModule,
                i4.NzDropDownModule,
                i2$2.NzGridModule,
                i9.NzIconModule,
                i1.NzInputModule,
                i5$1.NzPaginationModule,
                i2$1.NzSpinModule,
                i2.NzSwitchModule,
                i3$1.NzTableModule,
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaDataTableModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [DataTableComponent, CustomDataTableCellComponent],
                        imports: [
                            i5.CommonModule,
                            i7.FormsModule,
                            i7.ReactiveFormsModule,
                            i3.NzButtonModule,
                            i4.NzDropDownModule,
                            i2$2.NzGridModule,
                            i9.NzIconModule,
                            i1.NzInputModule,
                            i5$1.NzPaginationModule,
                            i2$1.NzSpinModule,
                            i2.NzSwitchModule,
                            i3$1.NzTableModule,
                        ],
                        exports: [DataTableComponent],
                    }]
            }] });

    var HeaderComponent = /** @class */ (function () {
        function HeaderComponent() {
            this.title = '';
            this.subTitle = '';
        }
        return HeaderComponent;
    }());
    HeaderComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: HeaderComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    HeaderComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: HeaderComponent, selector: "x-header", inputs: { title: "title", subTitle: "subTitle", tags: "tags", primaryButton: "primaryButton", secondaryButtons: "secondaryButtons", ellipsisDropdownItems: "ellipsisDropdownItems", breadcrumbItems: "breadcrumbItems", navRoutes: "navRoutes" }, ngImport: i0__namespace, template: "<nz-page-header class=\"x-app-header\">\n  <!-- breadcrumbs -->\n  <nz-breadcrumb *ngIf=\"breadcrumbItems?.length\" nzSeparator=\">\" nz-page-header-breadcrumb>\n    <nz-breadcrumb-item *ngFor=\"let breadcrumb of breadcrumbItems\">\n      <a *ngIf=\"breadcrumb.routerLink\" [routerLink]=\"breadcrumb.routerLink\">\n        {{ breadcrumb.name }}\n      </a>\n      <ng-container *ngIf=\"!breadcrumb.routerLink\">{{ breadcrumb.name }}</ng-container>\n    </nz-breadcrumb-item>\n  </nz-breadcrumb>\n\n  <!--title-->\n  <nz-page-header-title>{{ title }}</nz-page-header-title>\n\n  <!--subtitle-->\n  <nz-page-header-subtitle *ngIf=\"subTitle\">{{ subTitle }}</nz-page-header-subtitle>\n\n  <!--tags-->\n  <nz-page-header-tags *ngIf=\"tags?.length\">\n    <nz-tag *ngFor=\"let tag of tags\" nzColor=\"{{ tag?.nzStatusColor || tag?.color }}\">\n      {{ tag?.text }}\n    </nz-tag>\n  </nz-page-header-tags>\n\n  <!-- action buttons and dropdown items-->\n  <nz-page-header-extra>\n    <ng-container *ngIf=\"secondaryButtons?.length\">\n      <button\n        *ngFor=\"let secondaryButton of secondaryButtons\"\n        nz-button\n        (click)=\"secondaryButton.action()\"\n        [disabled]=\"secondaryButton.disabled\">\n        <i *ngIf=\"secondaryButton.nzIconName\" nz-icon [nzType]=\"secondaryButton.nzIconName\"></i>\n        {{ secondaryButton.text }}\n      </button>\n    </ng-container>\n    <button\n      *ngIf=\"primaryButton\"\n      nz-button\n      nzType=\"primary\"\n      (click)=\"primaryButton.action()\"\n      [disabled]=\"primaryButton.disabled\">\n      <i *ngIf=\"primaryButton.nzIconName\" nz-icon [nzType]=\"primaryButton.nzIconName\"></i>\n      {{ primaryButton?.text }}\n    </button>\n    <ng-container *ngIf=\"ellipsisDropdownItems?.length\">\n      <button\n        nz-button\n        nzNoAnimation\n        nz-dropdown\n        [nzDropdownMenu]=\"menu\"\n        style=\"border: none; padding: 0\">\n        <i\n          nz-icon\n          nzType=\"ellipsis\"\n          nzTheme=\"outline\"\n          style=\"font-size: 20px; vertical-align: top\"></i>\n      </button>\n      <nz-dropdown-menu #menu=\"nzDropdownMenu\">\n        <ul nz-menu>\n          <li *ngFor=\"let dropdownItem of ellipsisDropdownItems\" nz-menu-item>\n            {{ dropdownItem.text }}\n          </li>\n        </ul>\n      </nz-dropdown-menu>\n    </ng-container>\n  </nz-page-header-extra>\n\n  <!-- navigation -->\n  <nz-page-header-content>\n    <ng-content></ng-content>\n    <div *ngIf=\"navRoutes?.length\">\n      <nz-tabset nzLinkRouter>\n        <nz-tab *ngFor=\"let route of navRoutes\">\n          <a\n            [attr.data-testid]=\"route.id\"\n            *nzTabLink\n            nz-tab-link\n            [routerLink]=\"[route.path]\"\n            routerLinkActive=\"active\">\n            {{ route.name }}\n          </a>\n        </nz-tab>\n      </nz-tabset>\n      <ng-template #extraTemplate></ng-template>\n    </div>\n  </nz-page-header-content>\n</nz-page-header>\n", styles: [".x-app-header{background:rgba(255,255,255,.57);border-bottom:1px solid rgba(0,0,0,.15);padding:24px 24px 0;display:flex;flex-direction:column;position:relative}.x-app-header:before{content:\"\";background-image:url(/assets/fleet-manager/pattern.svg);background-repeat:no-repeat;background-position:right;width:100%;height:100%;position:absolute;right:0;top:0;opacity:.18;pointer-events:none}.x-app-header .ant-page-header-heading-title{font-family:\"Shell\";font-weight:600;font-size:32px;line-height:40px;margin-left:20px}.ant-tag{border-radius:12px}\n"], components: [{ type: i1__namespace$1.NzPageHeaderComponent, selector: "nz-page-header", inputs: ["nzBackIcon", "nzGhost", "nzTitle", "nzSubtitle"], outputs: ["nzBack"], exportAs: ["nzPageHeader"] }, { type: i2__namespace$2.NzBreadCrumbComponent, selector: "nz-breadcrumb", inputs: ["nzAutoGenerate", "nzSeparator", "nzRouteLabel", "nzRouteLabelFn"], exportAs: ["nzBreadcrumb"] }, { type: i2__namespace$2.NzBreadCrumbItemComponent, selector: "nz-breadcrumb-item", inputs: ["nzOverlay"], exportAs: ["nzBreadcrumbItem"] }, { type: i3__namespace$2.NzTagComponent, selector: "nz-tag", inputs: ["nzMode", "nzChecked", "nzColor"], outputs: ["nzOnClose", "nzCheckedChange"], exportAs: ["nzTag"] }, { type: i3__namespace.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { type: i4__namespace.NzDropdownMenuComponent, selector: "nz-dropdown-menu", exportAs: ["nzDropdownMenu"] }, { type: i6__namespace.NzTabSetComponent, selector: "nz-tabset", inputs: ["nzTabPosition", "nzCanDeactivate", "nzAddIcon", "nzTabBarStyle", "nzType", "nzSize", "nzAnimated", "nzTabBarGutter", "nzHideAdd", "nzCentered", "nzHideAll", "nzLinkRouter", "nzLinkExact", "nzSelectedIndex", "nzTabBarExtraContent"], outputs: ["nzSelectChange", "nzSelectedIndexChange", "nzTabListScroll", "nzClose", "nzAdd"], exportAs: ["nzTabset"] }, { type: i6__namespace.NzTabComponent, selector: "nz-tab", inputs: ["nzTitle", "nzClosable", "nzCloseIcon", "nzDisabled", "nzForceRender"], outputs: ["nzSelect", "nzDeselect", "nzClick", "nzContextmenu"], exportAs: ["nzTab"] }], directives: [{ type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1__namespace$1.NzPageHeaderBreadcrumbDirective, selector: "nz-breadcrumb[nz-page-header-breadcrumb]", exportAs: ["nzPageHeaderBreadcrumb"] }, { type: i5__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i8__namespace$1.RouterLinkWithHref, selector: "a[routerLink],area[routerLink]", inputs: ["routerLink", "target", "queryParams", "fragment", "queryParamsHandling", "preserveFragment", "skipLocationChange", "replaceUrl", "state", "relativeTo"] }, { type: i1__namespace$1.NzPageHeaderTitleDirective, selector: "nz-page-header-title, [nz-page-header-title]", exportAs: ["nzPageHeaderTitle"] }, { type: i1__namespace$1.NzPageHeaderSubtitleDirective, selector: "nz-page-header-subtitle, [nz-page-header-subtitle]", exportAs: ["nzPageHeaderSubtitle"] }, { type: i1__namespace$1.NzPageHeaderTagDirective, selector: "nz-page-header-tags, [nz-page-header-tags]", exportAs: ["nzPageHeaderTags"] }, { type: i1__namespace$1.NzPageHeaderExtraDirective, selector: "nz-page-header-extra, [nz-page-header-extra]", exportAs: ["nzPageHeaderExtra"] }, { type: i7__namespace$1.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { type: i8__namespace.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { type: i9__namespace.NzIconDirective, selector: "[nz-icon]", inputs: ["nzRotate", "nzSpin", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { type: i4__namespace.NzDropdownButtonDirective, selector: "[nz-button][nz-dropdown]" }, { type: i4__namespace.NzDropDownDirective, selector: "[nz-dropdown]", inputs: ["nzDropdownMenu", "nzTrigger", "nzMatchWidthElement", "nzHasBackdrop", "nzBackdrop", "nzClickHide", "nzDisabled", "nzVisible", "nzOverlayClassName", "nzOverlayStyle", "nzPlacement"], outputs: ["nzVisibleChange"], exportAs: ["nzDropdown"] }, { type: i10__namespace.NzMenuDirective, selector: "[nz-menu]", inputs: ["nzInlineIndent", "nzTheme", "nzMode", "nzInlineCollapsed", "nzSelectable"], outputs: ["nzClick"], exportAs: ["nzMenu"] }, { type: i10__namespace.NzMenuItemDirective, selector: "[nz-menu-item]", inputs: ["nzDisabled", "nzSelected", "nzDanger", "nzMatchRouterExact", "nzMatchRouter", "nzPaddingLeft"], exportAs: ["nzMenuItem"] }, { type: i1__namespace$1.NzPageHeaderContentDirective, selector: "nz-page-header-content, [nz-page-header-content]", exportAs: ["nzPageHeaderContent"] }, { type: i6__namespace.NzTabLinkTemplateDirective, selector: "ng-template[nzTabLink]", exportAs: ["nzTabLinkTemplate"] }, { type: i6__namespace.NzTabLinkDirective, selector: "a[nz-tab-link]", exportAs: ["nzTabLink"] }, { type: i8__namespace$1.RouterLinkActive, selector: "[routerLinkActive]", inputs: ["routerLinkActiveOptions", "routerLinkActive"], exportAs: ["routerLinkActive"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: HeaderComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'x-header',
                        templateUrl: './header.component.html',
                        styleUrls: ['./header.component.scss'],
                    }]
            }], propDecorators: { title: [{
                    type: i0.Input
                }], subTitle: [{
                    type: i0.Input
                }], tags: [{
                    type: i0.Input
                }], primaryButton: [{
                    type: i0.Input
                }], secondaryButtons: [{
                    type: i0.Input
                }], ellipsisDropdownItems: [{
                    type: i0.Input
                }], breadcrumbItems: [{
                    type: i0.Input
                }], navRoutes: [{
                    type: i0.Input
                }] } });

    var UmbrellaHeaderModule = /** @class */ (function () {
        function UmbrellaHeaderModule() {
        }
        return UmbrellaHeaderModule;
    }());
    UmbrellaHeaderModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaHeaderModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    UmbrellaHeaderModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaHeaderModule, declarations: [HeaderComponent], imports: [i5.CommonModule,
            i8$1.RouterModule,
            i1$1.NzPageHeaderModule,
            i6.NzTabsModule,
            i2$3.NzBreadCrumbModule,
            i3$2.NzTagModule,
            i3.NzButtonModule,
            i4.NzDropDownModule,
            i9.NzIconModule], exports: [HeaderComponent] });
    UmbrellaHeaderModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaHeaderModule, imports: [[
                i5.CommonModule,
                i8$1.RouterModule,
                i1$1.NzPageHeaderModule,
                i6.NzTabsModule,
                i2$3.NzBreadCrumbModule,
                i3$2.NzTagModule,
                i3.NzButtonModule,
                i4.NzDropDownModule,
                i9.NzIconModule,
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaHeaderModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [HeaderComponent],
                        imports: [
                            i5.CommonModule,
                            i8$1.RouterModule,
                            i1$1.NzPageHeaderModule,
                            i6.NzTabsModule,
                            i2$3.NzBreadCrumbModule,
                            i3$2.NzTagModule,
                            i3.NzButtonModule,
                            i4.NzDropDownModule,
                            i9.NzIconModule,
                        ],
                        exports: [HeaderComponent],
                    }]
            }] });

    var FooterComponent = /** @class */ (function () {
        function FooterComponent() {
        }
        FooterComponent.prototype.ngOnInit = function () { };
        return FooterComponent;
    }());
    FooterComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: FooterComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    FooterComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: FooterComponent, selector: "x-footer", inputs: { primaryButton: "primaryButton", secondaryButtons: "secondaryButtons" }, ngImport: i0__namespace, template: "<div nz-col nzJustify=\"end\">\n  <div nz-row nzJustify=\"end\" class=\"x-app-footer-logo-container\">\n    <div nz-col class=\"x-app-footer-logo\"></div>\n  </div>\n  <div\n    *ngIf=\"primaryButton || secondaryButtons\"\n    nz-row\n    nzJustify=\"end\"\n    class=\"x-app-footer-buttons\">\n    <ng-container *ngIf=\"secondaryButtons?.length\">\n      <button\n        *ngFor=\"let secondaryButton of secondaryButtons\"\n        nz-button\n        (click)=\"secondaryButton.action()\"\n        [disabled]=\"secondaryButton.disabled\">\n        <i *ngIf=\"secondaryButton.nzIconName\" nz-icon [nzType]=\"secondaryButton.nzIconName\"></i>\n        {{ secondaryButton.text }}\n      </button>\n    </ng-container>\n    <button\n      *ngIf=\"primaryButton\"\n      nz-button\n      nzType=\"primary\"\n      (click)=\"primaryButton.action()\"\n      [disabled]=\"primaryButton.disabled\">\n      <i *ngIf=\"primaryButton.nzIconName\" nz-icon [nzType]=\"primaryButton.nzIconName\"></i>\n      {{ primaryButton?.text }}\n    </button>\n  </div>\n</div>\n", styles: [":host{background:var(--x-color-background-base);min-height:40px;bottom:0;position:relative}.x-app-footer-logo-container{background:var(--x-color-background-base)}.x-app-footer-logo{background-image:url(/assets/fleet-manager/shell-recharge.svg);background-repeat:no-repeat;background-size:contain;width:140px;min-height:40px;margin:24px 24px 12px 0}.x-app-footer-buttons{background:#fff;padding:12px}.ant-btn{margin-left:12px!important}\n"], components: [{ type: i3__namespace.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }], directives: [{ type: i2__namespace$3.NzColDirective, selector: "[nz-col],nz-col,nz-form-control,nz-form-label", inputs: ["nzFlex", "nzSpan", "nzOrder", "nzOffset", "nzPush", "nzPull", "nzXs", "nzSm", "nzMd", "nzLg", "nzXl", "nzXXl"], exportAs: ["nzCol"] }, { type: i2__namespace$3.NzRowDirective, selector: "[nz-row],nz-row,nz-form-item", inputs: ["nzAlign", "nzJustify", "nzGutter"], exportAs: ["nzRow"] }, { type: i5__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i7__namespace$1.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { type: i8__namespace.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { type: i9__namespace.NzIconDirective, selector: "[nz-icon]", inputs: ["nzRotate", "nzSpin", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: FooterComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'x-footer',
                        templateUrl: './footer.component.html',
                        styleUrls: ['./footer.component.scss'],
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { primaryButton: [{
                    type: i0.Input
                }], secondaryButtons: [{
                    type: i0.Input
                }] } });

    var UmbrellaFooterModule = /** @class */ (function () {
        function UmbrellaFooterModule() {
        }
        return UmbrellaFooterModule;
    }());
    UmbrellaFooterModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaFooterModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    UmbrellaFooterModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaFooterModule, declarations: [FooterComponent], imports: [i5.CommonModule, i2$2.NzGridModule, i3.NzButtonModule, i9.NzIconModule], exports: [FooterComponent] });
    UmbrellaFooterModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaFooterModule, imports: [[i5.CommonModule, i2$2.NzGridModule, i3.NzButtonModule, i9.NzIconModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaFooterModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [FooterComponent],
                        imports: [i5.CommonModule, i2$2.NzGridModule, i3.NzButtonModule, i9.NzIconModule],
                        exports: [FooterComponent],
                    }]
            }] });

    /* Ant icon definitions */
    var icons = [icons$1.EditOutline, icons$1.PlusOutline, icons$1.DeleteOutline, icons$1.WarningOutline];
    var UmbrellaLibraryModule = /** @class */ (function () {
        function UmbrellaLibraryModule() {
        }
        return UmbrellaLibraryModule;
    }());
    UmbrellaLibraryModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    UmbrellaLibraryModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryModule, declarations: [UmbrellaLibraryComponent], imports: [
            /* Angular Modules */
            i5.CommonModule,
            i7.ReactiveFormsModule,
            /* Umbrella Modules */
            UmbrellaHeaderModule,
            UmbrellaFooterModule,
            UmbrellaDataTableModule,
            /* Ant Modules */
            anchor.NzAnchorModule,
            i2$3.NzBreadCrumbModule,
            i3.NzButtonModule,
            card.NzCardModule,
            cascader.NzCascaderModule,
            collapse.NzCollapseModule,
            divider.NzDividerModule,
            drawer.NzDrawerModule,
            form.NzFormModule,
            i2$2.NzGridModule,
            i9.NzIconModule, i9__namespace.NzIconModule, i1.NzInputModule,
            inputNumber.NzInputNumberModule,
            message.NzMessageModule,
            modal.NzModalModule,
            i1$1.NzPageHeaderModule,
            i5$1.NzPaginationModule,
            radio.NzRadioModule,
            result.NzResultModule,
            select.NzSelectModule,
            space.NzSpaceModule,
            i2$1.NzSpinModule,
            i2.NzSwitchModule,
            i3$1.NzTableModule,
            i6.NzTabsModule,
            i3$2.NzTagModule,
            tooltip.NzToolTipModule,
            typography.NzTypographyModule
        ], exports: [
            /* Angular Modules */
            i5.CommonModule,
            i7.ReactiveFormsModule,
            /* Umbrella Modules */
            UmbrellaHeaderModule,
            UmbrellaFooterModule,
            UmbrellaDataTableModule,
            /* Ant Modules */
            anchor.NzAnchorModule,
            i2$3.NzBreadCrumbModule,
            i3.NzButtonModule,
            card.NzCardModule,
            cascader.NzCascaderModule,
            collapse.NzCollapseModule,
            divider.NzDividerModule,
            drawer.NzDrawerModule,
            form.NzFormModule,
            i2$2.NzGridModule,
            i9.NzIconModule,
            i1.NzInputModule,
            inputNumber.NzInputNumberModule,
            message.NzMessageModule,
            modal.NzModalModule,
            i1$1.NzPageHeaderModule,
            i5$1.NzPaginationModule,
            radio.NzRadioModule,
            result.NzResultModule,
            select.NzSelectModule,
            space.NzSpaceModule,
            i2$1.NzSpinModule,
            i2.NzSwitchModule,
            i3$1.NzTableModule,
            i6.NzTabsModule,
            i3$2.NzTagModule,
            tooltip.NzToolTipModule,
            typography.NzTypographyModule
        ] });
    UmbrellaLibraryModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryModule, imports: [[
                /* Angular Modules */
                i5.CommonModule,
                i7.ReactiveFormsModule,
                /* Umbrella Modules */
                UmbrellaHeaderModule,
                UmbrellaFooterModule,
                UmbrellaDataTableModule,
                /* Ant Modules */
                anchor.NzAnchorModule,
                i2$3.NzBreadCrumbModule,
                i3.NzButtonModule,
                card.NzCardModule,
                cascader.NzCascaderModule,
                collapse.NzCollapseModule,
                divider.NzDividerModule,
                drawer.NzDrawerModule,
                form.NzFormModule,
                i2$2.NzGridModule,
                i9.NzIconModule,
                i9.NzIconModule.forChild(icons),
                i1.NzInputModule,
                inputNumber.NzInputNumberModule,
                message.NzMessageModule,
                modal.NzModalModule,
                i1$1.NzPageHeaderModule,
                i5$1.NzPaginationModule,
                radio.NzRadioModule,
                result.NzResultModule,
                select.NzSelectModule,
                space.NzSpaceModule,
                i2$1.NzSpinModule,
                i2.NzSwitchModule,
                i3$1.NzTableModule,
                i6.NzTabsModule,
                i3$2.NzTagModule,
                tooltip.NzToolTipModule,
                typography.NzTypographyModule,
            ],
            /* Angular Modules */
            i5.CommonModule,
            i7.ReactiveFormsModule,
            /* Umbrella Modules */
            UmbrellaHeaderModule,
            UmbrellaFooterModule,
            UmbrellaDataTableModule,
            /* Ant Modules */
            anchor.NzAnchorModule,
            i2$3.NzBreadCrumbModule,
            i3.NzButtonModule,
            card.NzCardModule,
            cascader.NzCascaderModule,
            collapse.NzCollapseModule,
            divider.NzDividerModule,
            drawer.NzDrawerModule,
            form.NzFormModule,
            i2$2.NzGridModule,
            i9.NzIconModule,
            i1.NzInputModule,
            inputNumber.NzInputNumberModule,
            message.NzMessageModule,
            modal.NzModalModule,
            i1$1.NzPageHeaderModule,
            i5$1.NzPaginationModule,
            radio.NzRadioModule,
            result.NzResultModule,
            select.NzSelectModule,
            space.NzSpaceModule,
            i2$1.NzSpinModule,
            i2.NzSwitchModule,
            i3$1.NzTableModule,
            i6.NzTabsModule,
            i3$2.NzTagModule,
            tooltip.NzToolTipModule,
            typography.NzTypographyModule] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: UmbrellaLibraryModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [UmbrellaLibraryComponent],
                        imports: [
                            /* Angular Modules */
                            i5.CommonModule,
                            i7.ReactiveFormsModule,
                            /* Umbrella Modules */
                            UmbrellaHeaderModule,
                            UmbrellaFooterModule,
                            UmbrellaDataTableModule,
                            /* Ant Modules */
                            anchor.NzAnchorModule,
                            i2$3.NzBreadCrumbModule,
                            i3.NzButtonModule,
                            card.NzCardModule,
                            cascader.NzCascaderModule,
                            collapse.NzCollapseModule,
                            divider.NzDividerModule,
                            drawer.NzDrawerModule,
                            form.NzFormModule,
                            i2$2.NzGridModule,
                            i9.NzIconModule,
                            i9.NzIconModule.forChild(icons),
                            i1.NzInputModule,
                            inputNumber.NzInputNumberModule,
                            message.NzMessageModule,
                            modal.NzModalModule,
                            i1$1.NzPageHeaderModule,
                            i5$1.NzPaginationModule,
                            radio.NzRadioModule,
                            result.NzResultModule,
                            select.NzSelectModule,
                            space.NzSpaceModule,
                            i2$1.NzSpinModule,
                            i2.NzSwitchModule,
                            i3$1.NzTableModule,
                            i6.NzTabsModule,
                            i3$2.NzTagModule,
                            tooltip.NzToolTipModule,
                            typography.NzTypographyModule,
                        ],
                        exports: [
                            /* Angular Modules */
                            i5.CommonModule,
                            i7.ReactiveFormsModule,
                            /* Umbrella Modules */
                            UmbrellaHeaderModule,
                            UmbrellaFooterModule,
                            UmbrellaDataTableModule,
                            /* Ant Modules */
                            anchor.NzAnchorModule,
                            i2$3.NzBreadCrumbModule,
                            i3.NzButtonModule,
                            card.NzCardModule,
                            cascader.NzCascaderModule,
                            collapse.NzCollapseModule,
                            divider.NzDividerModule,
                            drawer.NzDrawerModule,
                            form.NzFormModule,
                            i2$2.NzGridModule,
                            i9.NzIconModule,
                            i1.NzInputModule,
                            inputNumber.NzInputNumberModule,
                            message.NzMessageModule,
                            modal.NzModalModule,
                            i1$1.NzPageHeaderModule,
                            i5$1.NzPaginationModule,
                            radio.NzRadioModule,
                            result.NzResultModule,
                            select.NzSelectModule,
                            space.NzSpaceModule,
                            i2$1.NzSpinModule,
                            i2.NzSwitchModule,
                            i3$1.NzTableModule,
                            i6.NzTabsModule,
                            i3$2.NzTagModule,
                            tooltip.NzToolTipModule,
                            typography.NzTypographyModule,
                        ],
                    }]
            }] });

    /*
     * Public API Surface of umbrella-library
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DataTableComponent = DataTableComponent;
    exports.FooterComponent = FooterComponent;
    exports.HeaderComponent = HeaderComponent;
    exports.UmbrellaDataTableModule = UmbrellaDataTableModule;
    exports.UmbrellaFooterModule = UmbrellaFooterModule;
    exports.UmbrellaHeaderModule = UmbrellaHeaderModule;
    exports.UmbrellaLibraryComponent = UmbrellaLibraryComponent;
    exports.UmbrellaLibraryModule = UmbrellaLibraryModule;
    exports.UmbrellaLibraryService = UmbrellaLibraryService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=umbrella-library.umd.js.map
