import { ActionButton, MenuDropdownItem } from '../models/common.model';
import { HeaderBreadcrumb, HeaderNavRoute, HeaderTag } from './header.model';
import * as i0 from "@angular/core";
export declare class HeaderComponent {
    title: string;
    subTitle?: string;
    tags?: HeaderTag[];
    primaryButton?: ActionButton;
    secondaryButtons?: ActionButton[];
    ellipsisDropdownItems?: MenuDropdownItem[];
    breadcrumbItems?: HeaderBreadcrumb[];
    navRoutes?: HeaderNavRoute[];
    static ɵfac: i0.ɵɵFactoryDeclaration<HeaderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<HeaderComponent, "x-header", never, { "title": "title"; "subTitle": "subTitle"; "tags": "tags"; "primaryButton": "primaryButton"; "secondaryButtons": "secondaryButtons"; "ellipsisDropdownItems": "ellipsisDropdownItems"; "breadcrumbItems": "breadcrumbItems"; "navRoutes": "navRoutes"; }, {}, never, ["*"]>;
}
